
# promisify.es6

**Promisify a callback-based function.**

![](https://img.shields.io/badge/build-passing-brightgreen.svg?style=flat-square)
![](https://img.shields.io/badge/coverage-100%25-brightgreen.svg?style=flat-square)

## Why Another Promisify Module?

- **Only 10 LOC** (and, therefore, much smaller than [`node-promisify`](https://github.com/nodegit/promisify-node) and [`promisify-node`](https://github.com/zoubin/node-promisify), for example).

- **Simple and clean code** (thanks to [ES6 features](https://nodejs.org/en/docs/es6/), such as, [arrow functions](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions) and the [spread operator](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Spread_operator)).

- **No dependencies.**

- **100% test coverage.**

## Installation

```
npm install --save promisify.es6
```

## Example

```javascript
const promisify = require('promisify.es6')

function sum (a, b, callback) {
  callback(null, a + b)
}

let promisifiedSum = promisify(sum)

promisifiedSum(1, 2).then(sum => {
  console.log(sum) // --> 3
})

```

## License
[WTFPL](http://www.wtfpl.net/) – Do What the F*ck You Want to Public License.

Made with :heart: by [@MarkTiedemann](https://twitter.com/MarkTiedemannDE).
