'use strict'

const promisify = require('./'), chalk = require('chalk')

/* Test IIFEs */

~function testFailsOnErrorPromise () {

  let message = 'fails on error promise'

  let promisifiedFoo = promisify((callback) => {
    callback(new Error())
  })

  promisifiedFoo().then(result => {
    testFailed(message)
  }).catch(error => {
    if (error) testSucceeded(message)
    else testFailed(message)
  })

}()

~function testSucceedsOnMultipleArgumentsPassedToPromise () {

  let message = 'succeeds on multiple arguments passed to promise'

  let promisifiedFoo = promisify((a, b, callback) => {
    callback(null, a + b)
  })

  promisifiedFoo(1, 2).then(result => {
    if (result === 3) testSucceeded(message)
    else testFailed(message)
  }).catch(error => {
    testFailed(message)
  })

}()

/* Test Utility Functions */

function testSucceeded (message) { console.log(chalk.green('✔ ') + message) }
function testFailed (message) { console.error(chalk.red('✘ ') + message); process.exit(1) }
